# cat nodeattrs

原文链接 : [https://www.elastic.co/guide/en/elasticsearch/reference/5.0/cat-nodeattrs.html#_columns](https://www.elastic.co/guide/en/elasticsearch/reference/5.0/cat-nodeattrs.html#_columns)

译文链接 : [http://www.apache.wiki/display/Elasticsearch/cat+nodeattrs](http://www.apache.wiki/display/Elasticsearch/cat+nodeattrs)

贡献者 : [那伊抹微笑](/display/~wangyangting)

**nodeattrs** 命令展示了指定的节点的属性。

```
% curl 192.168.56.10:9200/_cat/nodeattrs
node    host    ip          attr  value
DKDM97B epsilon 192.168.1.8 rack  rack314
DKDM97B epsilon 192.168.1.8 azone us-east-1
```

前几列展示了每一个节点的基础信息。

```
node    host    ip
DKDM97B epsilon 192.168.1.8
DKDM97B epsilon 192.168.1.8
```

**attr** 和 **value** 列展示了节点属性中自定义的描述。

```
attr  value
rack  rack314
azone us-east-1
```

## Columns（列）

下面是一个已存在的 **header**（标题）的详细列表，它可以传递 **nodeattrs?h=** 以在有序的列中获取更详细的信息。如果没有指定 **header**（标题），那么这些标记默认情况下就会有。如果指定了 **header**（标题），将不使用默认值。

为了更简洁，可以使用别名替换完整的标题名称。列的显示是有序的，它们在下面被列出了，除非指定了其它的顺序（例如，**h=attr**，**value **与 **h=value**，**attr** 相反）。

在指定标题时，默认的输出中标题不会被替换。为了使标题可以出现在输出中，使用 **verbose**（详细的）模式（**v**）。标题名将匹配提供的值（例如，**pid** 与 **p** 相对）。例如 : 

```
% curl 192.168.56.10:9200/_cat/nodeattrs?v&h=name,pid,attr,value
name    pid   attr  value
DKDM97B 28000 rack  rack314
DKDM97B 28000 azone us-east-1
```

| Header（标题） | Alias（别名） | Appear by Default（默认显示） | Description（描述） | Example（示例） |
| --- | --- | --- | --- | --- |
| `node` | `name` | Yes | Name of the node | DKDM97B |
| `id` | `nodeId` | No | Unique node ID | k0zy |
| `pid` | `p` | No | Process ID | 13061 |
| `host` | `h` | Yes | Host name | n1 |
| `ip` | `i` | Yes | IP address | 127.0.1.1 |
| `port` | `po` | No | Bound transport port | 9300 |
| `attr` | `attr.name` | Yes | Attribute name | rack |
| `value` | `attr.value` | Yes | Attribute value | rack123 |