# zip 或 tar.gz 安装

原文链接 : [https://www.elastic.co/guide/en/elasticsearch/reference/current/zip-targz.html](https://www.elastic.co/guide/en/elasticsearch/reference/current/zip-targz.html)

译文链接 : [http://apache.wiki/pages/editpage.action?pageId=4882722](http://apache.wiki/pages/editpage.action?pageId=4882722)

贡献者 : @漫步

## zip 或 tar.gz 安装

Elasticsearch 提供了`.zip`与作为`.tar.gz`包。这些包可用于任何系统上安装 Elasticsearch并且使用简单的 Elasticsearch的包格式。

Elasticsearch 的最新稳定版本可以在 [Elasticsearch](https://www.elastic.co/downloads/elasticsearch)页面下载。其它版本可以在上 之前的下载也面找到。

```
Elasticsearch需要Java 8或更高版本。使用 Oracle官方发布或作为开放源代码的分布的OpenJDK。
```

## 下载.zip 安装包

在`.zip`为Elasticsearch V5.0.1压缩文件可以下载并安装如下：

wget https://artifacts.elastic.co/downloads/elasticsearch/elasticsearch-5.0.1.zip

```
sha1sum elasticsearch-5.0.1.zip ![](img/24cb6cd12df1a0cbdb39ab06379bd3de.jpg)
unzip elasticsearch-5.0.1.zip
cd elasticsearch-5.0.1/ ![](img/c7d178c0e490b3b3fa632f5c43fa27ff.jpg)
```

| [![](img/24cb6cd12df1a0cbdb39ab06379bd3de.jpg)](https://www.elastic.co/guide/en/elasticsearch/reference/current/zip-targz.html#CO1-1) | 通过比较产生的SHA `sha1sum`或`shasum`与  [published SHA](https://artifacts.elastic.co/downloads/elasticsearch/elasticsearch-5.0.1.zip.sha1). |
| [![](img/c7d178c0e490b3b3fa632f5c43fa27ff.jpg)](https://www.elastic.co/guide/en/elasticsearch/reference/current/zip-targz.html#CO1-2) | 该目录被称为`$ES_HOME`。 |

## 下载.tar.gz 安装包

在`.tar.gz`为Elasticsearch V5.0.1压缩文件可以下载并安装如下：

```
wget https://artifacts.elastic.co/downloads/elasticsearch/elasticsearch-5.0.1.tar.gz
sha1sum elasticsearch-5.0.1.tar.gz ![](img/24cb6cd12df1a0cbdb39ab06379bd3de.jpg)
tar -xzf elasticsearch-5.0.1.tar.gz
cd elasticsearch-5.0.1 / ![](img/c7d178c0e490b3b3fa632f5c43fa27ff.jpg)

```

| [![](img/24cb6cd12df1a0cbdb39ab06379bd3de.jpg)](https://www.elastic.co/guide/en/elasticsearch/reference/current/zip-targz.html#CO2-1) | Compare the SHA produced by `sha1sum` or `shasum` with the [published SHA](https://artifacts.elastic.co/downloads/elasticsearch/elasticsearch-5.0.1.tar.gz.sha1). |
| [![](img/c7d178c0e490b3b3fa632f5c43fa27ff.jpg)](https://www.elastic.co/guide/en/elasticsearch/reference/current/zip-targz.html#CO2-2) | This directory is known as `$ES_HOME`. |

## 在命令行中运行Elasticsearch

Elasticsearch可以从命令行启动，如下所示：

```
./bin/elasticsearch
```

默认情况下，Elasticsearch在前台运行，其打印日志到标准输出（`stdout`），并且可以通过按下停止`Ctrl-C`。

## 检查Elasticsearch运行

您可以测试你的Elasticsearch节点通过发送一个HTTP请求到端口上运行`9200`的`localhost`：

```
GET /
```

返回的消息应该是这样的：

```
{
  "name" : "Cp8oag6",
  "cluster_name" : "elasticsearch",
  "cluster_uuid" : "AT69_T_DTp-1qgIJlatQqA",
  "version" : {
    "number" : "5.0.1",
    "build_hash" : "f27399d",
    "build_date" : "2016-03-30T09:51:41.449Z",
    "build_snapshot" : false,
    "lucene_version" : "6.2.1"
  },
  "tagline" : "You Know, for Search"
}
```

要退出打印，在命令行输入-q 或 --quiet 选项在命令行上

## 作为守护程序运行

要运行Elasticsearch作为一个守护进程，指定`-d`在命令行上，并使用记录进程ID文件中的`-p`选项：

```
./bin/elasticsearch -d -p PID
```

日志信息可以在找到`$ES_HOME/logs/`的目录。

要关闭Elasticsearch，杀记录的过程中ID `pid`文件：

```
kill `cat pid`
```

![注意](img/66451d8bfad3b8dc5776cc1eafdf57b6.jpg)

在提供的启动脚本[RPM](https://www.elastic.co/guide/en/elasticsearch/reference/current/rpm.html "用RPM安装Elasticsearch")和[Debian的](https://www.elastic.co/guide/en/elasticsearch/reference/current/deb.html "Debian的软件包安装Elasticsearch") 包带启动和停止Elasticsearch过程。

## 在命令行配置Elasticsearch

Elasticsearch加载从它的配置`$ES_HOME/config/elasticsearch.yml` 默认文件。这个配置文件的格式说明[_配置Elasticsearch_](https://www.elastic.co/guide/en/elasticsearch/reference/current/settings.html "配置Elasticsearch")。

可以在配置文件中指定的任何设置，也可以在命令行上指定，使用`-E`的语法如下：

```
./bin/elasticsearch -d -Ecluster.name = my_cluster -Enode.name = node_1
```

![小费](img/b1fda39d66362520c57fb0bebf6575f8.jpg)

通常情况下，任何集群范围的设置（例如`[cluster.name](http://cluster.name)`）应该被加入到`elasticsearch.yml`配置文件，而任何特定于节点的设置，例如`[node.name](http://node.name)`可以在命令行上被指定。

## 目录结构`.zip`和`.tar.gz 的文档`

在`.zip`和`.tar.gz`包是完全独立的。所有的文件和目录，默认情况下，包含在`$ES_HOME` -解压缩存档时创建的目录。

这是非常方便，因为你没有创建任何目录开始使用Elasticsearch和卸载Elasticsearch是去掉了容易`$ES_HOME`目录。不过，最好是改变config目录，数据目录和日志目录的默认位置，这样你就不会删除以后重要的数据。

| 类型 | 描述 | 默认位置 | 设置 |
| --- | --- | --- | --- |
| **主目录** | Elasticsearch主目录或 `$ES_HOME` | 目录由解包归档创建 |   |
| **执行文件** | 二进制脚本包括`elasticsearch`启动一个节点，并`elasticsearch-plugin`安装插件 | `$ES_HOME/bin` |   |
| 配置文件 | 配置文件，包括 `elasticsearch.yml` | `$ES_HOME/config` | `path.conf` |
| **数据** | 节点上分配的各索引/碎片的数据文件的位置。可以容纳多个位置。 | `$ES_HOME/data` | `path.data` |
| **日志** | 日志文件的位置。 | `$ES_HOME/logs` | `path.logs` |
| **插件** | 插件文件的位置。每一个插件将被包含在一个子目录。 | `$ES_HOME/plugins` |   |
| **仓库** | 共享文件系统存储库位置。可以容纳多个位置。文件系统存储库可以放在这里指定的任意目录中的任何子目录。 | 未配置 | `path.repo` |
| **脚本** | 脚本文件位置。 | `$ES_HOME/scripts` | `path.scripts` |

## 下一步

现在，您有一个测试环境Elasticsearch成立。开始之前严重的发展或进入生产与Elasticsearch，你需要做一些额外的设置：

*   了解如何[配置Elasticsearch](https://www.elastic.co/guide/en/elasticsearch/reference/current/settings.html "配置Elasticsearch")。
*   配置[重要Elasticsearch设置](https://www.elastic.co/guide/en/elasticsearch/reference/current/important-settings.html "重要Elasticsearch配置")。
*   配置[重要的系统设置](https://www.elastic.co/guide/en/elasticsearch/reference/current/system-config.html "重要的系统配置")。