# Wildcard Query(通配符查询)

原文链接 : [https://www.elastic.co/guide/en/elasticsearch/reference/current/query-dsl-wildcard-query.html](https://www.elastic.co/guide/en/elasticsearch/reference/current/query-dsl-wildcard-query.html)

译文链接 : [http://www.apache.wiki/pages/viewpage.action?pageId=4260861](http://www.apache.wiki/pages/viewpage.action?pageId=4260861)

贡献者 : @小布丁

匹配与通配符表达式具有匹配字段的文档（**not analyzed**）。支持的通配符是 “*”，它匹配任何字符序列（包括空字符）；还有 “？”，它匹配任何单个字符。请注意，此查询可能很慢，因为它需要迭代多个项。为了防止极慢的通配符查询，通配符项不应以通配符 “*” 或 “？” 开头。通配符查询对应 **Lucene** 的 **WildcardQuery **。

```
GET /_search
{
    "query": {
        "wildcard" : { "user" : "ki*y" }
    }
}
```

_ boost_ 也可以与查询相关联：

```
GET /_search
{
    "query": {
        "wildcard" : { "user" : { "value" : "ki*y", "boost" : 2.0 } }
    }
}
```

或者这样：

```
GET /_search
{
    "query": {
        "wildcard" : { "user" : { "wildcard" : "ki*y", "boost" : 2.0 } }
    }
}
```

此多项查询允许如何控制使用 _rewrite_ 参数重写。