# Span 查询

原文链接 : [https://www.elastic.co/guide/en/elasticsearch/reference/5.4/span-queries.html](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/span-queries.html)

译文链接 : [http://www.apache.wiki/pages/viewpage.action?pageId=10029263](http://www.apache.wiki/pages/viewpage.action?pageId=10029263)

贡献者 : [片刻](/display/~jiangzhonglian) [ApacheCN](/display/~apachecn) [Apache中文网](/display/~apachechina)

Span查询是低级位置查询，可以提供对指定条款的顺序和接近度的专家控制。这些通常用于对法律文件或专利执行非常具体的查询。

Span查询不能与非跨查询（span_multi查询除外）混合。

该组中的查询是：

*   span_term查询
    *   等同于`[term](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/query-dsl-term-query.html "Term Query") `查询，但与其他Span查询一起使用。
*   span_multi查询
    *   包含[`term`](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/query-dsl-term-query.html "Term Query"), [`range`](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/query-dsl-range-query.html "Range Query"), [`prefix`](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/query-dsl-prefix-query.html "Prefix Query"), [`wildcard`](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/query-dsl-wildcard-query.html "Wildcard Query"), `[regexp](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/query-dsl-regexp-query.html "Regexp Query") 或者` [`fuzzy`](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/query-dsl-fuzzy-query.html "Fuzzy Query") 查询。
*   span_first查询
    *   接受另一个Span查询，其匹配必须出现在字段的前N个位置。
*   span_near查询
    *   接受多个Span查询，其匹配必须在彼此的指定距离内，并且可能以相同的顺序。
*   span_or查询
    *   组合多个Span查询 - 返回与任何指定查询匹配的文档。
*   span_not查询
    *   包装另一个Span查询，并排除与该查询匹配的任何文档。
*   span_containing查询
    *   接受Span查询的列表，但仅返回也匹配第二个Span查询的跨度。
*   span_within查询
    *   单个Span查询的结果将返回，只要其跨度位于由其他Span查询列表返回的范围内。
*   field_masking_span查询
    *   允许跨越不同字段`span-near` 或者 `span-or` 的查询。