# 字段类型

原文链接 : [https://www.elastic.co/guide/en/elasticsearch/reference/current/mapping-types.html](https://www.elastic.co/guide/en/elasticsearch/reference/current/mapping-types.html)

译文链接 : [字段类型](/pages/viewpage.action?pageId=7372806)

贡献者 : @装X帝

## 核心类型

字符串 ( string )

**_text, keyword_**

数字类型 ( Numeric )

**_long, integer, short, byte, double, float,half_float,scaled_float_**

日期类型 ( Date )

_**date**_

布尔类型 ( Boolean )

_**boolean**_

二进制类型 ( binary )

_**binary**_

## 复合类型

数组类型 ( Array )

**_Array_** 支持不针对特定的类型

对象类型 ( Object )

_**object**_ 用于单JSON对象

嵌套类型 (Nested )

**_nested_** 用于JSON对象数组

## 地理类型 ( Geo )

地理坐标 ( Geo-points )

**_geo_point _**用于描述 经纬度坐标

地理图形 ( Geo-Shape )

**_geo_shape_** 用于描述复杂形状，如多边形

## 特定类型

IP 类型

**_ip_** 用于描述 ipv4 和 ipv6 地址

补全类型 ( Completion  )

**_completion_** 提供自动完成提示

令牌计数类型 ( Token count )

**_token_count_** 用于统计字符串中的词条数量

附件类型 ( attachment )

参考 **_mapper-attachements _**插件，支持将附件如Microsoft Office格式，Open Document格式，ePub，HTML等等索引为 **_attachment_** 数据类型。

抽取类型 ( Percolator )

接受特定领域查询语言（query-dsl）的查询

## 多字段

通常用于为不同目的用不同的方法索引同一个字段。例如，**_string_** 字段可以映射为一个 _**text**_ 字段用于全文检索，同样可以映射为一个 **_keyword_** 字段用于排序和聚合。另外，你可以使用 _**standard analyzer，english analyzer，french analyzer **_来索引一个** _text_**字段

这就是 **_muti-fields _**的目的。大多数的数据类型通过fields参数来支持** _muti-fields_**。