# URL-based access control（基于 URL 的访问控制）

原文链接 : [https://www.elastic.co/guide/en/elasticsearch/reference/5.4/url-access-control.html](https://www.elastic.co/guide/en/elasticsearch/reference/5.4/url-access-control.html)

译文链接 : [http://www.apache.wiki/pages/viewpage.action?pageId=4882853](http://www.apache.wiki/pages/viewpage.action?pageId=4882853)

贡献者 : [小瑶](/display/~chenyao)，[ApacheCN](/display/~apachecn)，[Apache中文网](/display/~apachechina)

许多用户使用具有基于 **URL** 的访问控制的代理来安全地访问 **Elasticsearch indices**（ **Elasticsearch** 索引）。对于 [multi-search](/pages/viewpage.action?pageId=4882778)（多重搜索 )，[multi-get（多重获取](/pages/viewpage.action?pageId=5505071)）和 [bulk](/display/Elasticsearch/Bulk+API) **requests**（批量请求），用户可以选择在 **URL** 中 和 **request body**（请求主体 )中的每个单独请求上指定索引。这可能使基于 **URL** 的访问控制具有挑战性。

要防止用户 **overriding the index which has been specified in the URL**（覆盖在 **URL** 中指定的索引），请将此设置添加到 **config.yml** 文件中：

```
rest.action.multi.allow_explicit_index: false
```

默认值是 **true** ，但是设置为 **false** 时， **Elasticsearch** 将拒绝在 **request body**（请求主体）中指定了明确索引的请求。